#!/usr/bin/env node

// require('../index.js');

const fs = require("fs");
const request = require("request");
const dirToObj = require("directory-tree")

const commandLineArgs = require('command-line-args')

const optionDefinitions = [
  { name: 'local', alias: 'l', type: String },
  { name: 'remote', alias: 'r', type: String },
]
const options = commandLineArgs(optionDefinitions);

if (!options.local || !options.remote){
  console.log('usage: diff-local-remote -l "./f1" -r "http://asdf.com/f1"')
  process.exit(0);
}


let localFolderPath = 
  options.local;



let baseUrl = 
  options.remote;

console.log({localFolderPath, baseUrl});

const sep = require("path").sep;


// localFolderPath = localFolderPath.substr(2);
if (localFolderPath[1] == ":"){
  
}
else {
  if (localFolderPath.indexOf("/") == 0){
    localFolderPath = localFolderPath.substr(1);
  }
  // else
  if (localFolderPath.indexOf("./") == 0){
    localFolderPath = localFolderPath.substr(2);
  }

  // localFolderPath = process.cwd() + "/"  + localFolderPath;
  localFolderPath = process.cwd() + sep  + localFolderPath;
  console.log("localFolder is " + localFolderPath);
  // process.exit(0);
}
// if (localFolderPath.indexOf("/") == 0){
//   localFolderPath = "." + localFolderPath;
// }
// // else
// if (localFolderPath.indexOf("./") != 0){
//   localFolderPath = "./" + localFolderPath;
// }




if (baseUrl.lastIndexOf("/") == baseUrl.length - 1){
  baseUrl = baseUrl.substr(0,baseUrl.length-1);
}

// const localPathToStrip = localFolderPath.substr(1);
// const localPathToStrip = localFolderPath;
let localPathToStrip = localFolderPath;
localPathToStrip = localPathToStrip.replace(/\\/g, "/")
console.log("localPathToStrip: " + localPathToStrip)

async function reqAsync(url){
  return new Promise((resolve, reject) => {
    request(url, function(err, data){
      if (err){
        reject(err);
      } else {
        return resolve({err, data:data.body})
      }
    })
  })
}

async function diff(path){
  console.log("comparing: " + path);
  // let url = baseUrl + "/" + path.replace(/\\/g, "/")
  let url = baseUrl +  path.replace(/\\/g, "/")
  url = url.replace(localPathToStrip, "");
  console.log("with url " + url);
  let remoteData = await reqAsync(url);
  remoteData = remoteData.data;
  const localData = fs.readFileSync(path);
  if (remoteData != localData){
    console.log("\nDIFFERENT: " + path + "\n")
   
  } else {
    // console.log("SAME: " + path);
  }
}

async function diffRecursive(node){

  if (node.type == "file"){
    await diff(node.path);
  } else {
    for (let subNode of node.children){
      await diffRecursive(subNode);
    }
  }
}

async function main(){
  var localFilesTree = dirToObj(localFolderPath);
  for (let subTree of localFilesTree.children){
    diffRecursive(subTree);
  }
}


main();


