
const fs = require("fs");
const request = require("request");
const dirToObj = require("directory-tree")

const commandLineArgs = require('command-line-args')

const optionDefinitions = [
  { name: 'local', alias: 'l', type: String },
  { name: 'remote', alias: 'r', type: String },
  // { name: 'crownpeakTargetFolderPath', alias: 'c', type: Number }
]
const options = commandLineArgs(optionDefinitions);

if (!options.local || !options.remove){
  console.log('usage: diff-local-remote -l "./f1" -r "http://asdf.com/f1"')
  process.exit(0);
}


// const localFolderPath = 
let localFolderPath = 
  options.local;
  // options.local ||
  // "./testInput/f2"
  // "./testInput/prs-cousins-4-25"
  // "./testInput/prs-cousins-4-25/client"
  // "./f1"
// const baseUrl = 
let baseUrl = 
  options.remote;
  // options.remote ||
  // "http://google.com"
  // "http://www2.chubb.com/individuals-families/finan"
  // "http://www2.chubb.com/expect-more/path-to-sucess"
  // "http://www.chubb.com/expect-more/path-to-success"
  // "http://www2.chubb.com/us/en/expect-more/path-to-success"
  // "http://www2.chubb.com/us/en/expect-more/path-to-success/client"

console.log({localFolderPath, baseUrl})

if (localFolderPath.indexOf("/") == 0){
  localFolderPath = "." + localFolderPath;
}
// else
if (localFolderPath.indexOf("./") != 0){
  localFolderPath = "./" + localFolderPath;
}
// "jksdlf".last
if (baseUrl.lastIndexOf("/") == baseUrl.length - 1){
  baseUrl = baseUrl.substr(0,baseUrl.length-1);
}

const localPathToStrip = localFolderPath.substr(1);

console.log({localFolderPath, baseUrl})

// process.exit(0);


// node .\diffing1.js -l "testInput/f2" -r "http://google.com/"
// node .\diffing1.js -l "testInput/f2" -r "http://google.com/"

// const a = request(baseUrl + "")
// console.log(request);
// request(baseUrl + "", function(err, data){
//   console.log(data)
// })

async function reqAsync(url){
  return new Promise((resolve, reject) => {
    console.log("requesting url " + url);
    request(url, function(err, data){
      if (err){
        console.log("err is " + err);
        reject(err);
      } else {
        // console.log("success, data is " + data)
        // console.log("success, data is " + data.body)
        // console.log(Object.keys(data));
        // return resolve({err, data})
        console.log("sucess with url " + url)
        return resolve({err, data:data.body})
      }
      // return resolve({err, data})
    })
  })
}

async function diff(path){
  if (path.indexOf("index") > -1 || path.includes("fav") || path.includes("404")){
    return;
  }
  // console.log("diffing " + path);
  console.log("comparing: " + path);
  // const url = baseUrl + path
  // const url = baseUrl + "/" + path.replace(/\\/g, "/")
  let url = baseUrl + "/" + path.replace(/\\/g, "/")
  url = url.replace(localPathToStrip, "");
  // const remoteData = await reqAsync(url);
  // const remoteData = (await reqAsync(url)).data;
  let remoteData = await reqAsync(url);
  remoteData = remoteData.data;
  const localData = fs.readFileSync(path);
  if (remoteData != localData){
    // console.log("different: " + path)
    console.log("DIFFERENT: " + path)
    // console.log(path)
    // console.log("remote: " + remoteData);
    // console.log("remote keys: " + Object.keys(remoteData));
    // console.log("local: " + localData);
    console.log(remoteData.length);
    console.log(localData.length);
    console.log("path again: " + path);
    // process.exit(0);
  } else {
    // console.log("SAME: " + path);
  }
}

async function diffRecursive(node){
  
  // if (node.children){

  // }
  // if (node.type == "folder"){
  
  
  // if (node.type == "directory"){
  //   for (let subNode of node.children){
  //     await diffRecursive(subNode);
  //   }
  // } else {
  //   await diff(node.path);
  // }

  if (node.type == "file"){
    await diff(node.path);
  } else {
    for (let subNode of node.children){
      await diffRecursive(subNode);
    }
  }
}

async function main(){
  // const a = await request(baseUrl);
  // const a = await reqAsync(baseUrl);
  // console.log("after, a is " + a)
  // console.log(Object.keys(a))
  // console.log(a.data);

  // console.log("in main")

  var localFilesTree = dirToObj(localFolderPath);
  for (let subTree of localFilesTree.children){
    // console.log("subtree");
    diffRecursive(subTree);
  }
}


// console.log("about to start main")
main();


// request(baseUrl, function(err,data){
// request(remo, function(err,data){
//   console.log(data.body)
// })